//+------------------------------------------------------------------+
//|                                                  ForBlackBox.mq4 |
//|                                        Copyright  2007, DocSoft |
//|                                                    http://---.ru |
//|------------------------------------------------------------------|
//| Ver.01. 30.05.09    TF: no tested                                |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, DocSoft"
#property link      "http://---.ru"

#property  indicator_separate_window
#property indicator_buffers 1
//!!#property indicator_buffers 2
#property indicator_color1  Gold
#property indicator_color2  Snow

//Input parameters
extern int  RSIOMA = 5;

//Indicator buffers
double ZoneBuff[];
//!!double ReDrawBuff[];


///////////////////////////////////////////////////////////
void init()
{
    IndicatorDigits(2);
    SetIndexBuffer(0, ZoneBuff);
    SetIndexStyle (0, DRAW_LINE);
    //!!SetIndexBuffer(1, ReDrawBuff);
    //!!SetIndexStyle (1, DRAW_LINE);

    IndicatorShortName("bb:"+RSIOMA);
    SetIndexLabel(0,   "bb:"+RSIOMA);

}
//=========================================================
void deinit()
{
}
//=========================================================

void start()
{
    //!!ReDrawBuff[0] = 
    Ind(ZoneBuff, RSIOMA);
}
//=========================================================

double Ind (double& buff[], int RSIOMA = 5)
{
    double rel,negative,positive;
    int i=Bars-RSIOMA-1;

    //----  
    double RSIbuf=0.0;
    //----
    while(i>=0) {
        double sumn=0.0,sump=0.0;

        if(i==Bars-RSIOMA-1) {
            int k=Bars-2;
            //----  ------
            while(k>=i) {

                double cma = iMA(Symbol(),0,RSIOMA,0,MODE_EMA,PRICE_CLOSE,k);
                double pma = iMA(Symbol(),0,RSIOMA,0,MODE_EMA,PRICE_CLOSE,k+1);

                rel=cma-pma;

                if(rel>0) sump+=rel;
                else sumn-=rel;
                k--;
            }
            positive=sump/RSIOMA;
            negative=sumn/RSIOMA;
        }

        //----    ------
        double ccma = iMA(Symbol(),0,RSIOMA,0,MODE_EMA,PRICE_CLOSE,i);
        double ppma = iMA(Symbol(),0,RSIOMA,0,MODE_EMA,PRICE_CLOSE,i+1);

        rel=ccma-ppma;

        if(rel>0) sump=rel;
        else sumn=-rel;
        positive=(positive*(RSIOMA-1)+sump)/RSIOMA;
        negative=(negative*(RSIOMA-1)+sumn)/RSIOMA;

        if(negative==0.0) RSIbuf=0.0;
        else RSIbuf=100.0-100.0/(1+positive/negative);

        buff[i] = RSIbuf;

        i--;
    }
    return(RSIbuf);
}
//=========================================================

